> For the complete documentation index, see [llms.txt](https://docs.fulfillmenttools.com/documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fulfillmenttools.com/documentation/apis/customer-defined-ids-in-requests.md).

# Customer-defined IDs in requests

fulfillmenttools allows specifying a customer-defined ID for certain entities. The ID format follows the pattern `tenant{ENTITY}Id`. This field allows for transferring IDs from external systems to the fulfillmenttools. If this ID is unambiguous, it enables reading and writing the entity using HTTP.

Currently, this functionality applies only to stock entities.

{% hint style="info" %}
For information on retrieving entities by their `tenant{ENTITY}Id` using a path parameter, refer to the [Uniform Resource Name (URN) pattern in path parameters](/documentation/apis/api-reference.md#uniform-resource-name-pattern-urn-in-path-parameters) documentation.
{% endhint %}

## Examples for stock

### Get stock with a user-defined ID

```http
GET https://ocff-{projectId}.api.fulfillmenttools.com/api/stocks?tenantFacilityId=CGN-01
```

### Search for stock with a user-defined ID

```http
POST https://ocff-{projectId}.api.fulfillmenttools.com/api/stocks/search
```

{% code title="Request body (JSON)" %}

```json
{
    "query": {
        "tenantFacilityId": {
            "eq": "CGN-01"
        }
    }
}
```

{% endcode %}

### Create stock with a user-defined ID via PUT

```http
PUT https://ocff-{projectId}.api.fulfillmenttools.com/api/stocks
```

{% code title="Request body (JSON)" %}

```json
{
    "stocks": [
        {
            "facility": {
                "tenantFacilityId": "CGN-01"
            },
            "tenantArticleId": "0188104",
            "value": 100
        }
    ]
}
```

{% endcode %}

### Create a stock with a user-defined ID via POST

```http
POST https://ocff-{projectId}.api.fulfillmenttools.com/api/stocks
```

{% code title="Request body (JSON)" %}

```json
{
    "facility": {
        "tenantFacilityId": "CGN-01"
    },
    "tenantArticleId": "0188104",
    "value": 101
}
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.fulfillmenttools.com/documentation/apis/customer-defined-ids-in-requests.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
